require("kara3d.vector")
require("kara3d.matrix")
require("kara3d.quaternion")
require("kara3d.transform")
require("utils")


light = {class = "light"}
light.__index = light


-- Creates a new light with transform t and RGB value diff and spec
function light.new(t, diff, spec)
  local l = {transform = t, diffuse = diff or vector.new(3, {255, 255, 255}), specular = spec or vector.new(3, {255, 255, 255})}
  setmetatable(l, light)
  return l
end



-- Clones this light
function light:clone()
  return light.new(self.transform, table.copy(self.diffuse), table.copy(self.specular))
end